#ifndef CA_PROTO_H
#define CA_PROTO_H
#include "pv.h"
//
/*#ifndef BYTE
#define BYTE	unsigned char
#define WORD	unsigned short
#define DWORD	unsigned long
#endif*/
// 128*256*256*256=2,147,483,648
#define 	SEC_FOR_20Y		631152000	//365.25*86400*20
#define 	SEC_FOR_70Y		2209075200  //
#define		SEC_2009Y		1229904000	//39*86400*365
#define 	SEC_2039Y		2175984000	//69*86400*365
//2208988800=366*86400*17(4,8~1968)+365*86400*53	//1900 is not leap year
//2209075200=2208988800+86400

#define 	SUCCESS		0
#define 	FAILURE		-1
/*
	EPICS definition start ------------------------------------
*/
#define CA_PROTO_VERSION		0
#define CA_PROTO_SEARCH			6
#define CA_PROTO_CLIENT_NAME	20
#define CA_PROTO_HOST_NAME		21
#define CA_PROTO_CREATE_CHAN	18
#define CA_PROTO_ACCESS_RIGHT	22
#define CA_PROTO_READ_NOTIFY	15
#define CA_PROTO_WRITE			4
#define CA_PROTO_RSRV_IS_UP		13
#define CA_PROTO_EVENT_ADD		1
#define CA_PROTO_ECHO			23	//V43
#define CA_PROTO_CLEAR_CHANNEL	12
//
// db_access.h
#define DBR_STRING			0
#define DBR_SHORT			1	
#define DBR_INT			1	
#define DBR_FLOAT			2	
#define DBR_ENUM			3	
#define DBR_CHAR			4	
#define DBR_LONG			5	
#define DBR_DOUBLE			6

#define DBR_TIME_STRING		14
#define DBR_TIME_SHORT		15
#define DBR_TIME_DOUBLE		20
#define DBR_CTRL_DOUBLE		34
/*
	EPICS definition end ------------------------------------
*/
//
#define CHECK_DOUBLE		0	//DBE_VALUE
#define CHECK_STRING		1	//DBE_VALUE
#define CHECK_LOG			2
#define CHECK_ARCHIVE		3	//DBE_LOG
//
// camonitor
//
#define DBE_VALUE			0x01
#define DBE_LOG				0x02
#define DBE_VALUE_LOG		0x03
#define DBE_ALARM			0x04
//-------------------------------------------------
#define CA_PROTO_ACCESS_RIGHT_NONE		0x00
#define CA_PROTO_ACCESS_RIGHT_READ		0x01
#define CA_PROTO_ACCESS_RIGHT_WRITE		0x02
#define CA_PROTO_ACCESS_RIGHT_RW		0x03
//
#define		UDP_LISTEN_PRIO	(MAIN_PRIO+1)
#define		UDP_SERVER_PRIO	(MAIN_PRIO+2)
#define		TCP_LISTEN_PRIO (MAIN_PRIO+3)
#define		BEACON_PRIO		(MAIN_PRIO+4)
#define		PV_CHECK_PRIO	(MAIN_PRIO+5)
#define		FTP_PRIO		(MAIN_PRIO-1)
#define		S0_PRIO			(MAIN_PRIO+7)
#define		S1_PRIO			(MAIN_PRIO+8)
//-------------------------------------------------
// error message
//
// only bi, bo, ai, ao, stringin, stringout are processed
// RT_ : record type
//-------------------------------------------------
/*#define RT_BI				0x0001	//binary input	
#define RT_BO				0x0002	//binary output
#define RT_AI				0x0003	//analog input
#define RT_AO				0x0004	//analog output
#define RT_STRINGIN			0x0005	//string input
#define RT_STRINGOUT		0x0006	//string output*/
#define MAX_STRING_SIZE		64
#define MAX_STRING_SIZE_P1	65
#define MAX_NAME_SIZE		28
#define MAX_NAME_SIZE_P1	29
#define MAX_PACKET_SIZE		512
//-------------------------------------------------
#define CA_SERVER_PORT		5064
#define CA_REPEATER_PORT	5065
#define UDP_SERVER_PORT		5066
//
#define CA_PROTO_MAJ_VER	4		// version 4.11
#define CA_PROTO_MIN_VER	11		// version 4.11
//
#define NFDS 				10		// Max number of file descriptors/connections 

//-------------------------------------------------
#define DO_REPLY			0x0A	//10
#define DONT_REPLY			0x05	//5
//-------------------------------------------------
#define		DEBUG_CA		0
#define		DEBUG_TIME		1
#define		DEBUG_MONITOR	0
#define		DEBUG_FILE		0
#define		DEBUG_FTP		0
#define		FTP_READ_ONLY	1

#define		DO_UPDATE		1		//IOC_GetData()
#define		DONT_UPDATE		2
//
// date time format, GetSystemTime()
#define		DATE_TIME_COMPACT		1	//YYYYMMDD_hhmmss, used for file system
#define 	DATE_TIME_NORMAL		2	//YYYY-MM-DD hh:mm:ss

//configuration
#define		CONFIG_FAILURE			0x0000
#define		CONFIG_NO_CHANGE		0x0001
#define		CONFIG_CHANGED			0x8000		//no need to reboot
#define		CONFIG_CHANGED_BOOT		0x4000		//need reboot
#define		CONFIG_CHANGED_MASK		0xC000
#define		MAX_CONFIG_LEN			1024
//
#define		MAX_AUTHORIZE_NUM	5
#define		MAX_UNITS_SIZE		8
//
#define		PVS_BLANK_MARKER	-2
//
#define FORMAT_NO_LOG		0		//no log
#define FORMAT_BINARY		1		//default binary data saving
#define FORMAT_TEXT			2
//
#define INTERFACE_RS232		1
#define INTERFACE_UDP		2
//
#define PROTO_UDP		1
#define PROTO_TCP		2
//
// return value for DecipherCommand()
#define IS_A_COMMAND	1
#define NOT_A_COMMAND	2
// payload data
//reference: \include\db_access.h
struct PL_DBR_CTRL_DOUBLE	//PL=payload, 88 bytes
{
	WORD wStatus;		//status of value
	WORD wSeverity;		//severity of alarm
	WORD wPrecision;	//number of decimal places
	WORD wRISC_PAD0;	//RISC align
	char szUnit[MAX_UNITS_SIZE];	//8 bytes
	double dHiDispLim;		//upper limit of graph
	double dLoDispLim;		//lower limit of graph
	double dHiAlarmLim;
	double dHiWarnLim;
	double dLoWarnLim;
	double dLoAlarmLim;	
	double dHiCtrlLim;		//upper control limit	
	double dLoCtrlLim;		//lower control limit
	double dValue;			//current value
};

struct PL_DBR_TIME_SHORT	//PL=payload
{
	WORD wStatus;		//status of value
	WORD wSeverity;		//severity of alarm
	DWORD dwTime1;
	DWORD dwTime2;
	short sRISC_PAD;	//RISC alignment
	short sValue;
};

struct PL_DBR_TIME_DOUBLE	//PL=payload
{
	WORD wStatus;		//status of value
	WORD wSeverity;		//severity of alarm
	DWORD dwTime1;
	DWORD dwTime2;
	DWORD dwRISC_PAD;	//RISC alignment
	double dValue;
};

struct PL_DBR_TIME_STRING	//PL=payload
{
	WORD wStatus;		//status of value
	WORD wSeverity;		//severity of alarm
	DWORD dwTime1;
	DWORD dwTime2;
	char szValue[MAX_STRING_SIZE_P1];
};
//
// PV
//
typedef struct PV_DOUBLE //analog output, input
{
	char szName[MAX_NAME_SIZE_P1];
	char szDescription[MAX_NAME_SIZE_P1];
	double dValue;
	double dNewValue;
	double dHysteresis;
	//double dScan;			//scan interval in second
	WORD wAccessRight;		//read:0x01, write:0x02
	WORD wStatus;
	WORD wSeverity;
	BYTE bLogged;
	BYTE bChanged;
	struct PL_DBR_CTRL_DOUBLE dbrCtrl;
} PV_DOUBLE;
//

typedef struct PV_SHORT //analog output, input
{
	char szName[MAX_NAME_SIZE_P1];
	char szDescription[MAX_NAME_SIZE_P1];
	short sValue;
	short sNewValue;
	double dHysteresis;
	//double dScan;			//scan interval in second
	WORD wAccessRight;		//read:0x01, write:0x02
	WORD wStatus;
	WORD wSeverity;
	BYTE bLogged;
	BYTE bChanged;
	struct PL_DBR_CTRL_DOUBLE dbrCtrl;
} PV_SHORT;

typedef struct PV_STRING
{
	char szName[MAX_NAME_SIZE_P1];
	char szDescription[MAX_NAME_SIZE_P1];
	char szValue[MAX_STRING_SIZE_P1];
	char szNewValue[MAX_STRING_SIZE_P1];
	WORD wAccessRight;		//read:0x01, write:0x02
	WORD wStatus;
	WORD wSeverity;
	//BYTE bLogged; //string log is not suppported
	BYTE bChanged;
} PV_STRING;
//
typedef struct CA_HEADER
{
	WORD wCommand;
	WORD wPayloadSize;	//in unit bytes
	WORD wDataType;		//TCP port, reply flag
	WORD wDataCount;
	DWORD	dwParam1;
	DWORD	dwParam2;
} CA_HEADER;

typedef struct CA_PACKET
{
	CA_HEADER caHeader;
	BYTE bData[MAX_PACKET_SIZE];		// must be a multiple of 8
} CA_PACKET;

typedef struct CAFD_SET	//NFDS
{
	int fdConn;
	IPADDR iaClient;
	WORD wClientPort;
} CAFD_SET;

typedef struct PV_SET	//NPVS
{
	int nFdNdx;		//fdConn index, several PV might use the same fdConn
	DWORD dwSID;	//subscriber ID
	DWORD dwCID;	//channel ID
	DWORD dwIOID;	//client provided IO ID
	DWORD dwCSID;	//PROTO_EVENT_ADD, clinet provided subscription ID
	char szPV[MAX_NAME_SIZE_P1];
	WORD wDataType;	//might be more than one type in one channel
	int nType;		//PV_TYPE_DOUBLE or PV_TYPE_STRING
	int nPvNdx;		//index for PV_STRING, PV_DOUBLE
	WORD wPort;
	WORD wMonitorMask;	//DBE_VALUE, DBE_LOG
	WORD wEventDataType;	//DBR_TIME_DOUBLE or DBR_TIME_STRING
	int nAuthorizedRW;	//authorized IP
	//float fScanInterval;	//archive interval
} PV_SET;

#define CA_HEADER_SIZE	sizeof(CA_HEADER)
//
// saved in NV_Settings (TBD), file format
// This is the structure that will be stored in Flash. It is also
// used to update variables at runtime. 
typedef struct NV_SETTINGS
{
	DWORD dwVerifyKey;
	char szDeviceName[MAX_NAME_SIZE_P1];
	BYTE bReserved[4];
	IPADDR iaNetMask;	//beacon broadcast net mask
	IPADDR iaNTP;	//NTP server IP address
	int nLogFormat;
	int nLogInterval;	//seconds	
	IPADDR iaAuthorized[MAX_AUTHORIZE_NUM];
	int nAuthorizedRW[MAX_AUTHORIZE_NUM]; //CA_PROTO_ACCESS_RIGHT_READ, CA_PROTO_ACCESS_RIGHT_WRITE
	int nTZOffset;		//time zone offset in min , Taiwan = UTC + 8*3600, nTZOffset = 480 min
	int nSerialOutput;	//
	int nAutoDelete;	//log file auto delete
	char szAuthorizedHC[MAX_AUTHORIZE_NUM][65];	//host client name
	int nNTPInterval;	//NTP refresh interval in min
	BYTE bReserved2[64];
} NV_SETTINGS;

typedef struct UDP_CLIENT
{
	IPADDR iaSource;
	int nSrcPort;		//source port
	int nDestPort;		//destination port
} UDP_CLIENT;
//
//-----------------------------------
// cas.cpp
//-----------------------------------
void CAS_Init(void);
//-----------------------------------
// utility.cpp
//-----------------------------------
void ShowTitleIP(char *szName, IPADDR iaV);
WORD IntToHexWord(int nV);
int GetNearestInt(double dV);
WORD ByteToWord(BYTE *pData);
int Make8(int nN);
char *Make3PNumber(long lV);
void GetUTCTime(char *szDateTime, int nFormat);
void GetSystemTime(char *szDateTime, int Format);
int SetSystemTime(char *szDateTime);
time_t ChangeToUTC1990(time_t time_val);
void IPtoString(IPADDR ia, char *s);
void PackChar(char *szBuffer, char *szPack);
//-----------------------------------
// user_param.cpp
//-----------------------------------
void CheckNVSettings(void);
void TimeCalibration(void);
void PV_UpdateChange(int nType, int nPvNdx, char *szValue);
int PV_GetPayload(WORD wType, int nPvNdx, BYTE *pPayload);
BOOL PV_DataChanged(int nType, int nPvNdx);
void PV_UpdateOneData(int nType, int nPvNdx);
void PV_UpdateData(int nType);
WORD PV_GetAccessRight(int nType, int nPvNdx);
WORD PV_GetDataType(int nType);
void PV_ListAll(void);
BOOL PV_IsExist(char *szPV, int *pnType, int *pnPvNdx);
void ShowUser(void);
void ShowTitle(void);
void TxString(char *szStr);
int  DecipherCommand(char *szCommand);
int  PV_GetNameList(int nType, char *szData, int nFormat);
int  PV_GetDataList(int nType, char *szData, int nFormat);
//int  GetAuthorizedIP(IPADDR iaV);
//int  GetAuthorizedUser(char *szH, char *szC);
int  CheckAuthorization(IPADDR iaV, char *szH, char *szC, int nPvSetNdx);
//
void PVS_SetMonitorMask(int nPvSetNdx, WORD wMask);
WORD PVS_GetMonitorMask(int nPvSetNdx);
void PVS_Clear(int nPvSetNdx);
void PVS_ClearFD(int nFdNdx);
void PVS_SetData(int nPvSetNdx, WORD wDataType, char *szValue);
int PVS_GetEmptyPvSet(void);
int PVS_GetPvSetNdxFromCID(DWORD dwCID);
int PVS_GetPvSetNdxFromSID(DWORD dwSID);
//-----------------------------------
// ioc.cpp
//-----------------------------------
void IOC_GetAllNewData(void);
void IOC_Init(void);
void IOC_GetData(int nPvNdx, int nType);
int IOC_SetData(int nPvNdx, int nType, void *pValue, int nLen);
void SerialOutput(int nPort, char *szMessage);
//
// log file use UTC time
// iaNetMask IP in cassetup.ini
// F_ATTR_DIR ... F_ATTR_ARV
// read/write test
// check autodelete function
// log file function, format test
// add time zone setting in cassetup.ini
// NTP function test
// DHCP function test
// log file auto delete
// acf file parser
// db file parser
//
#endif	//CA_PROTO_H
