//
#ifndef FFS_H
#define FFS_H
//
#include "pv.h"
#include "cardtype.h"

extern char EffsErrorCode[][30];

#define MAX_EFFS_ERRORCODE   ( 38 )
#define F_SUCCESS				0
#define F_FAILURE				-1
//
#define F_IS_SAME_FILE			60	//no new file needed
#define F_IS_NEW_FILE			61	//new file needed

#define F_IS_SAME_MONTH			62	//no new file needed
#define F_IS_NEW_MONTH			63	//new file needed
	
typedef struct LOG_DATA_HEADER
{
	char szPV_Name[128];
} LOG_DATA_HEADER;

typedef struct LOG_DATA
{
	DWORD dwTime;
	float fData[PV_DBL_NUM];	//PV_LOG_NUM=PV_DBL_NUM+PV_SHORT_NUM
	short sData[PV_SHORT_NUM];
} LOG_DATA;
//

typedef struct FILE_PROC_PARAM
{
	BOOL bDumpDir;
	BOOL bFormat;
	BOOL bDeleteDir;
	char szDir[10];
} FILE_PROC_PARAM;
	
#ifdef __cplusplus
extern "C"
{
#endif

//FAT Media Types for Format
#define F_FAT12_FORMAT (1)
#define F_FAT16_FORMAT (2)
#define F_FAT32_FORMAT (3) 

int InitExtFlash(void);
int UnmountExtFlash(void);
int DisplayEffsSpaceStats(void);
int GoToDirectory(char *szDateTime);
int UpdateLogData(void);
void SerialOutput(void);
//int WriteLogData(BYTE *pData, int nBytes);
int DumpDir(void);
int DumpOneDir(char *szDir);
int ReadConfigurationFile(void);
void FileProcess(void);

#ifdef __cplusplus
}
#endif
//
#endif
