/*---------------------------------------
	ioc.cpp
---------------------------------------*/
#include "predef.h" 
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <startnet.h>
#include <autoupdate.h>
#include <dhcpclient.h>
#include <nbtime.h>
#include <serial.h>
//#include <udp.h>
//#include <tcp.h>
#include <taskmon.h>
#include <NetworkDebug.h>
#include <..\mod5282\system\sim5282.h>
//#include <ucos.h>
#include <pins.h>
#include "rtc.h"
#include "ca_proto.h"
#include "cardtype.h"
//
#include <effs_fat/fat.h>
#ifdef USE_MMC
#include <effs_fat/mmc_mcf.h>
#endif
#ifdef USE_CFC
#include <effs_fat/cfc_mcf.h>
#endif
//
int fdSerial1;
//
DWORD Serial0Stack[USER_TASK_STK_SIZE];
DWORD Serial1Stack[USER_TASK_STK_SIZE];
void Serial0Task(void * pd);
void Serial1Task(void * pd);

extern PV_DOUBLE pvDouble[PV_DBL_NUM];	//defined in user_param.cpp
extern PV_STRING pvString[PV_STR_NUM];	//defined in user_param.cpp
extern PV_SHORT pvShort[PV_SHORT_NUM];
extern int nTxInterface;
//
void InitializeQADC()
{
	J2[10].hiz();
	J2[10].function(1);	//
	J2[7].hiz();
	J2[7].function(1);	//
	J2[8].hiz();
	J2[8].function(1);	//
	J2[6].hiz();
	J2[6].function(1);	//
	J2[12].hiz();
	J2[12].function(1);	//
	J2[11].hiz();
	J2[11].function(1);	//
	J2[13].hiz();
	J2[13].function(1);	//
	J2[9].hiz();
	J2[9].function(1);	//
	//
	sim.qadc.qadcmcr = 0x8000;
	sim.qadc.portqa = 0;
	sim.qadc.portqb = 0;
	sim.qadc.ddrqa = 0;
	sim.qadc.ddrqb = 0;
	sim.qadc.qacr0 = 0x10;	/* FQCLK = 66.355MHz/(2*(16+1)) 1.952MHZ AD clock and 2MHZ is maximum accuracy*/
	sim.qadc.qacr1 = 0x1100; /* Continuous software scans in queue 1 */
	sim.qadc.qacr2 = 11;  	/* Disable queue 2 with Queue 1 ending at position 11 */
	sim.qadc.qasr0 = 0;
	sim.qadc.qadcmcr = 0x0000;
	asm(" nop");
	sim.qadc.ccw[0] = 0xC0;  /* Convert channel 0 see 5282 users manual table 28-16 */
	sim.qadc.ccw[1] = 0xC1;  /* Channel 1 */
	sim.qadc.ccw[2] = 0xC2;  /* Channel 2 */
	sim.qadc.ccw[3] = 0xC3;  /* Channel 3 */
	sim.qadc.ccw[4] = 0xF4;  /* Channel 4 (52) */
	sim.qadc.ccw[5] = 0xF5;  /* Channel 5 (53) */
	sim.qadc.ccw[6] = 0xF7;  /* Channel 6 (55) */
	sim.qadc.ccw[7] = 0xF8;  /* Channel 7 (56) */
	sim.qadc.ccw[8] = 0xFC;  /* Should return a measured 0 */
	sim.qadc.ccw[9] = 0xFD;  /* Should return a measured 1023 or max */
	sim.qadc.ccw[10] = 0xFE; /* Should return half scale or 512 */
	sim.qadc.ccw[11] = 0xFF; /* End of Queue Code */
	sim.qadc.qacr1 = 0x1100; /* Continuous software scans in queue 1 */
}
/*-------------------------------------------------------------------
 * Returns the Right-Justified Unsigned Result Register (RJURR)
 * value for the specified A/D input channel. Channel numbers for
 * this example program are 0-7 for the external A/D inputs, and 
 * ch = 0 ~ 7, return voltage  
 * ----------------------------------------------------------------*/
float GetQADC(int nCh)
{
	float fV;
	fV = (float)sim.qadc.rjurr[nCh] * 3.3 / 1024.0;
	return fV;
}

/* 
	IOC_GetAllNewData(): get all hardware value into xNewValue
	IOC_GetNewData(): get specific hardware value to xNewValue
	PV_UpdateData(): set xValue from xNewValue
*/
void IOC_GetAllNewData(void)
{
	//get ai, stringin, di value
	int nPvNdx;
	//
	for (nPvNdx = 0; nPvNdx < PV_SHORT_NUM; nPvNdx++) {	
		IOC_GetData(nPvNdx, PV_TYPE_SHORT);
	}
	for (nPvNdx = 0; nPvNdx < PV_DBL_NUM; nPvNdx++) {
		IOC_GetData(nPvNdx, PV_TYPE_DOUBLE);
	}
	for (nPvNdx = 0; nPvNdx < PV_STR_NUM; nPvNdx++)	{
		IOC_GetData(nPvNdx, PV_TYPE_STRING);
	}
}

void Serial0Task(void * pd)
{
	char szBuffer[MAX_STRING_SIZE_P1];
	int nNdx = 0;
	char c;
	//
	while (1)	{
		while (charavail())	{
			c = getchar();
			if (c == '\n') {
				szBuffer[nNdx] = 0;
				nTxInterface = INTERFACE_RS232;
				iprintf("\n");
				if (DecipherCommand(szBuffer) == NOT_A_COMMAND) //output to CA channel, reserved
					strcpy(pvString[S0_NDX].szNewValue, szBuffer);
				nNdx = 0;
			}
			else if (nNdx == MAX_STRING_SIZE) {
				szBuffer[nNdx + 1] = 0;
				strcpy(pvString[S0_NDX].szNewValue, szBuffer);
				nNdx = 0;
			}
			else if (c != '\r') { //skip \r
				szBuffer[nNdx++] = c;
			}
		}
		OSTimeDly(1); // 50 msec
	}
}

void Serial1Task(void * pd)
{
	char szBuffer[MAX_STRING_SIZE_P1];
	int rv, nNdx = 0;
	char c;
	//
	while (1)
	{
		while (dataavail(fdSerial1)) {
			rv = read(fdSerial1, &c, 1);
			if (c == '\n') {	//do nothing
			}
			else if (c == '\r') {
				szBuffer[nNdx] = 0;
				strcpy(pvString[S1_NDX].szNewValue, szBuffer);
				nNdx = 0;
			}
			else if (nNdx == MAX_STRING_SIZE)	{
				szBuffer[nNdx + 1] = 0;
				strcpy(pvString[S1_NDX].szNewValue, szBuffer);
				nNdx = 0;
			}
			else if (c != '\r')	{
				szBuffer[nNdx++] = c;
			}
		}
		OSTimeDly(1); // 50 msec
	}
}
/*
 IOC_Init(), IOC_GetData(), IOC_SetData() 
 are the functions need to be changed to accommodate different hardware
*/
void IOC_Init()
{	
	int i, nNdx;
	//database initialization
	//
	//pvString[0] => Serial0, pvString[1] => Serial1, pvString[2] => Date, time
	//
	for (i = 0; i < PV_SHORT_NUM; i++)
		memset((BYTE *)&pvShort[i], 0, sizeof(PV_SHORT));
	for (i = 0; i < PV_DBL_NUM; i++)
		memset((BYTE *)&pvDouble[i], 0, sizeof(PV_DOUBLE));
	for (i = 0; i < PV_STR_NUM; i++)
		memset((BYTE *)&pvString[i], 0, sizeof(PV_STRING));
	///////////////////////////////////////////////////////////////////////////
	//Wrapper function start
	for (i = AI_START; i <= AI_END; i++)
	{
		sprintf(pvDouble[i].szName, "ai%d", i - AI_START);
		sprintf(pvDouble[i].szDescription, "analog input %d", i - AI_START);
		pvDouble[i].wAccessRight = CA_PROTO_ACCESS_RIGHT_RW;
		pvDouble[i].dHysteresis = 0.05;
		pvDouble[i].bLogged = TRUE;
		pvDouble[i].dbrCtrl.wPrecision = 3;
		strcpy(pvDouble[i].dbrCtrl.szUnit, "volts");
		pvDouble[i].dbrCtrl.dHiDispLim = 3.3;
		pvDouble[i].dbrCtrl.dLoDispLim = 0;
		pvDouble[i].dbrCtrl.dHiAlarmLim = 3.3;
		pvDouble[i].dbrCtrl.dHiWarnLim = 3.3;
		pvDouble[i].dbrCtrl.dLoWarnLim = 0;
		pvDouble[i].dbrCtrl.dHiCtrlLim = 3.3;
		pvDouble[i].dbrCtrl.dLoCtrlLim = 0;
	}
	// ***
	nNdx = DO_NDX;
	strcpy(pvDouble[nNdx].szName, "do");
	strcpy(pvDouble[nNdx].szDescription, "digital output");
	pvDouble[nNdx].wAccessRight = CA_PROTO_ACCESS_RIGHT_RW;
	pvDouble[nNdx].dHysteresis = 0;
	pvDouble[nNdx].bLogged = TRUE;
	pvDouble[nNdx].dbrCtrl.wPrecision = 0;
	pvDouble[nNdx].dbrCtrl.szUnit[0] = 0;
	pvDouble[nNdx].dbrCtrl.dHiDispLim = 255;
	pvDouble[nNdx].dbrCtrl.dLoDispLim = 0;
	pvDouble[nNdx].dbrCtrl.dHiAlarmLim = 256;
	pvDouble[nNdx].dbrCtrl.dHiWarnLim = 256;
	pvDouble[nNdx].dbrCtrl.dLoWarnLim = 0;
	pvDouble[nNdx].dbrCtrl.dHiCtrlLim = 255;
	pvDouble[nNdx].dbrCtrl.dLoCtrlLim = 0;
	//
	nNdx = DI_NDX;
	strcpy(pvDouble[nNdx].szName, "di");
	strcpy(pvDouble[nNdx].szDescription, "digital input");
	pvDouble[nNdx].wAccessRight = CA_PROTO_ACCESS_RIGHT_RW;
	pvDouble[nNdx].dHysteresis = 0;
	pvDouble[nNdx].bLogged = TRUE;
	pvDouble[nNdx].dbrCtrl.wPrecision = 0;
	pvDouble[nNdx].dbrCtrl.szUnit[0] = 0;
	pvDouble[nNdx].dbrCtrl.dHiDispLim = 255;
	pvDouble[nNdx].dbrCtrl.dLoDispLim = 0;
	pvDouble[nNdx].dbrCtrl.dHiAlarmLim = 256;
	pvDouble[nNdx].dbrCtrl.dHiWarnLim = 256;
	pvDouble[nNdx].dbrCtrl.dLoWarnLim = 0;
	pvDouble[nNdx].dbrCtrl.dHiCtrlLim = 255;
	pvDouble[nNdx].dbrCtrl.dLoCtrlLim = 0;
	//
	nNdx = SEG_NDX;			//putdisp(WORD wV);
	strcpy(pvDouble[nNdx].szName, "seg");
	strcpy(pvDouble[nNdx].szDescription, "7-seg display");
	pvDouble[nNdx].wAccessRight = CA_PROTO_ACCESS_RIGHT_RW;
	pvDouble[nNdx].dHysteresis = 0;
	pvDouble[nNdx].bLogged = TRUE;
	//
	strcpy(pvString[S0_NDX].szName, "s0");
	strcpy(pvString[S0_NDX].szDescription, "serial0 input");
	pvString[S0_NDX].wAccessRight = CA_PROTO_ACCESS_RIGHT_RW;
	//
	// PV_TYPE_SHORT is not used in this sample code
	//for (i = 0; i < PV_SHORT_NUM; i++)
	//	pvShort[i].szName[0] = 0;
	// PV string
	strcpy(pvString[S1_NDX].szName, "s1");
	strcpy(pvString[S1_NDX].szDescription, "serial1 input");
	pvString[S1_NDX].wAccessRight = CA_PROTO_ACCESS_RIGHT_RW;
	//
	strcpy(pvString[RTC_NDX].szName, "rtc");
	strcpy(pvString[RTC_NDX].szDescription, "RTC clock");
	pvString[RTC_NDX].wAccessRight = CA_PROTO_ACCESS_RIGHT_RW;
	//Wrapper function end
	///////////////////////////////////////////////////////////////////////////
	// serial port task initialization
	SerialClose(1); // close UART 1
	fdSerial1 = OpenSerial(1, 115200, 1, 8, eParityNone);
	if (fdSerial1 < 0)
		iprintf("serial1 open failure\r\n");
	
	if (OSTaskCreate(Serial0Task,
			(void *)CA_REPEATER_PORT,
			&Serial0Stack[USER_TASK_STK_SIZE],
			Serial0Stack,
			S0_PRIO) != OS_NO_ERR)
			iprintf("Serial0Task creation error\n");
	if (OSTaskCreate(Serial1Task,
			(void *)CA_REPEATER_PORT,
			&Serial1Stack[USER_TASK_STK_SIZE],
			Serial1Stack,
			S1_PRIO) != OS_NO_ERR)
			iprintf("Serial1Task creation error\n");
	InitializeQADC();
}
/*
	response for caget
	get hardware value and save into xNewValue 
*/
void IOC_GetData(int nPvNdx, int nType)
{
	///////////////////////////////////////////////////////////////////////////
	//Wrapper function start
	switch (nType)
	{
		case PV_TYPE_SHORT:
			if (nPvNdx == DIS_NDX)	{ //digital input, no function	
				pvShort[nPvNdx].sNewValue = (short)getdipsw();
			}
			break;
		case PV_TYPE_DOUBLE:
			if (nPvNdx == DI_NDX) { //digital input, no function	
				pvDouble[nPvNdx].dNewValue = (double)getdipsw();
			}
			else if (nPvNdx >= AI_START && nPvNdx <= AI_END) {
				pvDouble[nPvNdx].dNewValue = (double)GetQADC(nPvNdx - AI_START);
			}
			break;
		case PV_TYPE_STRING:
			if (nPvNdx == S0_NDX) {	//serial0 input
				//serial0 data is got from Serial0Task()
			}
			else if (nPvNdx == S1_NDX) {//serial1 input
				//serial1 data is got from Serial1Task()
			}
			else if (nPvNdx == RTC_NDX) { //set day time to RTC chip and system time
				GetSystemTime(pvString[2].szNewValue, DATE_TIME_NORMAL);
			}
			break;
	}
	//Wrapper function end
	///////////////////////////////////////////////////////////////////////////
}

/*
	command for caput
	set settings to hardware 
*/
int IOC_SetData(int nPvNdx, int nType, void *pValue, int nLen)
{
	///////////////////////////////////////////////////////////////////////////
	//Wrapper function start
	double dValue;
	//short sValue;
	int nV;
	WORD wV;
	short sValue;
	//
	switch (nType) {
		case PV_TYPE_SHORT:	//digital output //PV_TYPE_SHORT is not used in this sample code
			sValue = *((short *)pValue);
			if (nPvNdx == DOS_NDX)	{ //digital output
				putleds((BYTE)sValue);
				return SUCCESS;
			}
			//else if (nPvNdx == DIS_NDX)	//digital input, no function
			else if (nPvNdx == SEG_NDX)	{ //7-segment display
				putdisp((WORD)sValue);
				return SUCCESS;
			}	
			break; 
		case PV_TYPE_DOUBLE:	//analog output
			if (nPvNdx == DO_NDX) {	//digital output
				dValue = *((double *)pValue);
				nV = GetNearestInt(dValue);
				putleds((BYTE)nV);
				return SUCCESS;
			}
			//else if (nPvNdx == 1)	//digital input, no function change for hardware
			else if (nPvNdx == SEG_NDX)	{ //7-segment display
				dValue = *((double *)pValue);
				nV = GetNearestInt(dValue);
				wV = IntToHexWord(nV);  //change 1000 to 0x1000
				putdisp(wV);	//wV = 0x0~0x9999
				return SUCCESS;
			}
			//else if (nPvNdx == AI_START ~ AI_END)	//analog input 0, no change for hardware
			break;
		case PV_TYPE_STRING:
			if (nPvNdx == 0) { //serial0 output
				printf((char *)pValue);
				return SUCCESS;
			}
			else if (nPvNdx == 1) {//serial1 output
				write(fdSerial1, (char *)pValue, nLen);
				return SUCCESS;
			}
			else if (nPvNdx == 2) { //set day time to RTC chip and system time
				return SetSystemTime((char *)pValue);
			} //date time format = "YYYY-MM-DD,hh:mm:ss" or "YYYY-MM-DD hh:mm:ss"
			break;
	}
	return FAILURE;
	//Wrapper function end
	///////////////////////////////////////////////////////////////////////////
}

void SerialOutput(int nPort, char *szMessage)
{
	strcat(szMessage, "\r\n");
	if (nPort == 1)
		write(fdSerial1, szMessage, strlen(szMessage));
	else if (nPort == 0)
		iprintf(szMessage);
}
