#include "predef.h"
#include <stdio.h>
#include <ctype.h>
#include <startnet.h>
#include <autoupdate.h>
#include <taskmon.h>
#include <smarttrap.h>
#include <dhcpclient.h>
#include <ftpd.h>
#include <nbtime.h>
//
#include <NetworkDebug.h>
#include "ca_proto.h"
#include "ffs.h"
#include "rtc.h"

#include <effs_fat/fat.h>
#ifdef USE_MMC
#include <effs_fat/mmc_mcf.h>
#endif
#ifdef USE_CFC
#include <effs_fat/cfc_mcf.h>
#endif

BOOL bInit;
extern NV_SETTINGS NV_Settings;

extern "C" 
{
void UserMain(void * pd);
}

const char * AppName="TinyCAS";

void UserMain(void * pd) 
{
	time_t t_now, t_prev = 0;
	bInit = FALSE;
	InitializeStack();
    //
    if (EthernetIP == 0) 
    {
    	iprintf("Try DHCP\n");
    	GetDHCPAddress();
    }
    OSChangePrio(MAIN_PRIO);
    EnableAutoUpdate();
    
	#ifdef _DEBUG
	InitializeNetworkGDB();
	#endif
	/* The following call to f_enterFS() must be called in every task that accesses
      the file system.  This must only be called once in each task and must be done before 
      any other file system functions are used.  Up to 10 tasks can be assigned to use
      the file system. Any task may also be removed from accessing the file system with a 
      call to the function f_releaseFS(). */
	f_enterFS(); // We now must also enter the file system for the FTP task
	OSChangePrio( FTP_PRIO );
	//
	f_enterFS(); // We now must also enter the file system for the PVCheck task
	OSChangePrio( PV_CHECK_PRIO );
	//
	f_enterFS(); 
	OSChangePrio( MAIN_PRIO );
	InitExtFlash(); //mount FAT
	
	FTPDStart( 21, FTP_PRIO ); //FTP server fucntion is not working so far
	//
	CAS_Init();
	OSTimeDly(TICKS_PER_SECOND/2);
	ShowTitle();
	//
	RTCSetSystemFromRTCTime();
	//
	OSTimeDly(5);	//
    iprintf("Tiny CAS started\n");
    bInit = TRUE;
    while (1) 
    {
        OSTimeDly(TICKS_PER_SECOND);
        t_now = time(NULL);
        if (t_now - t_prev > (long)NV_Settings.nNTPInterval * 60) {
        	t_prev = t_now;
        	TimeCalibration(); //Get NTP time
        }
        	
    }
    UnmountExtFlash();  
	f_releaseFS(); 
}
